Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 125053)
+++ channels/chan_sip.c	(working copy)
@@ -10321,8 +10321,9 @@
 		}
 	}
 
-	copy_socket_data(&peer->socket, &req->socket);
-	copy_socket_data(&pvt->socket, &peer->socket);
+	if (peer->socket.type == req->socket.type)
+		copy_socket_data(&peer->socket, &req->socket);
+	copy_socket_data(&pvt->socket, &req->socket);
 
 	/* Look for brackets */
 	curi = contact;
@@ -10941,6 +10942,25 @@
 					res = 0;
 					break;
 				}
+
+				if (peer->socket.type != req->socket.type) {
+					if (peer->socket.type & (SIP_TRANSPORT_UDP | SIP_TRANSPORT_TCP)) {
+						ast_log(LOG_WARNING, 
+							"peer '%s' has contacted us over %s even though it is configured for %s.\n", 
+							peer->name, get_transport(req->socket.type), get_transport(peer->socket.type)
+						);
+					} else {
+						ast_log(LOG_ERROR,
+							"peer '%s' has contacted us over %s, but we are configured for TLS! ending call.\n"
+							peer->name, get_transport(req->socket.type)
+						);
+
+						ast_set_flag(&p->flags[0], SIP_PENDINGBYE);
+						transmit_response_with_date(p, "403 Forbidden", req);
+						res = 0;
+						break;
+					}
+				}
 			} 
 		}
 	}
